  PROGRAM
  INCLUDE('SaTzi.inc'),ONCE
  MAP
  END

cTzi SaTziClass
CurrentUTC   LONG
LocalTime    LONG

W    WINDOW('Time Zone Information'),AT(,,245,252),FONT('MS Sans Serif',8,,,CHARSET:ANSI),CENTER,SYSTEM, |
         GRAY
       PROMPT('Year:'),AT(9,15),USE(?Prompt15),FONT(,,,FONT:bold)
       SPIN(@n_4),AT(42,15,33,10),USE(cTzi.tzYear),RIGHT(2)
       PROMPT('Change the year to see time zone dates.   To see new time zones, change the time' &|
           ' zone in Windows Date/Time properties dialog.'),AT(79,7,161,30),USE(?Prompt1)
       BUTTON('&Refresh Time Zone Information'),AT(42,41,167,14),USE(?RefreshButton)
       PANEL,AT(23,71,213,35),USE(?Panel1),BEVEL(-1)
       STRING(@s32),AT(85,116,154,10),USE(cTzi.StandardZoneName,,?StandardZoneName),FONT(,,,FONT:bold)
       PROMPT('Bias in minutes:'),AT(28,162),USE(?p4:2)
       STRING(@n-4),AT(207,162),USE(cTzi.tzi.StandardBias),RIGHT
       STRING(@n-4),AT(207,231),USE(cTzi.tzi.DaylightBias),RIGHT
       PROMPT('Bias in minutes:'),AT(28,231),USE(?p4:3)
       STRING(@s32),AT(85,185,154,10),USE(cTzi.DaylightZoneName,,?DaylightZoneName),FONT(,,,FONT:bold)
       PROMPT('Local Time:'),AT(28,74),USE(?Prompt4)
       STRING(@T7),AT(203,74),USE(LocalTime),RIGHT
       PROMPT('Active time zone:'),AT(8,60),USE(?p1),FONT(,,,FONT:bold)
       STRING(@s32),AT(85,60,154,10),USE(cTzi.CurrentZoneName,,?CurrentZoneName),FONT(,,,FONT:bold)
       PROMPT('Current UTC:'),AT(28,84),USE(?P3)
       STRING(@T7),AT(203,84),USE(CurrentUTC),RIGHT
       PROMPT('Bias in minutes:'),AT(28,95),USE(?p4)
       STRING(@n-4),AT(207,95),USE(cTzi.ActiveTimeBias),RIGHT
       PROMPT('Standard time zone:'),AT(8,116),USE(?Prompt5),FONT(,,,FONT:bold)
       PANEL,AT(23,127,213,47),USE(?Panel2),BEVEL(-1)
       PROMPT('Starts on:'),AT(28,130),USE(?Prompt7)
       STRING(@s40),AT(62,130,163,10),USE(cTzi.StandardStartDateStr),RIGHT
       PROMPT('Starts on date:'),AT(28,140),USE(?Prompt13)
       STRING(@D17),AT(179,140),USE(cTzi.StandardStartDate,,?StandardStartDate),HIDE,RIGHT
       PROMPT('Starts on date:'),AT(28,210),USE(?Prompt13:2)
       STRING(@s40),AT(62,199,163,10),USE(cTzi.DaylightStartDateStr,,?DaylightStartDateStr),RIGHT
       PROMPT('Starts at:'),AT(28,151),USE(?Prompt8)
       STRING(@T7),AT(203,151),USE(cTzi.StandardStartTime,,?StandardStartTime),HIDE,RIGHT
       STRING(@D17),AT(179,210),USE(cTzi.DaylightStartDate,,?DaylightStartDate),HIDE,RIGHT
       STRING(@T7),AT(203,220),USE(cTzi.DaylightStartTime,,?DaylightStartTime),HIDE,RIGHT
       PROMPT('Starts at:'),AT(28,220),USE(?Prompt8:2)
       PROMPT('Starts on:'),AT(28,199),USE(?Prompt7:2)
       PROMPT('Daylight time zone:'),AT(8,185),USE(?Prompt6),FONT(,,,FONT:bold)
       PANEL,AT(23,196,213,47),USE(?Panel3),BEVEL(-1)
     END

  CODE


  OPEN(W)
  cTzi.tzYear = YEAR(TODAY())

  POST(EVENT:Accepted,?RefreshButton)
  ACCEPT
    CASE FIELD()
    OF ?RefreshButton
      IF EVENT() = EVENT:Accepted
        IF cTzi.GetTimeZoneInfo() = TZI_SUCCESS

          !Test the time conversion methods
          CurrentUTC = cTzi.LocalTimeToUTC(CLOCK())
          LocalTime  = cTzi.UTCtoLocalTime(CurrentUTC)

          !Hide the transition time and date controls if there's no transition
          ?StandardStartTime{PROP:Hide} = CHOOSE(cTzi.StandardStartTime = TZI_NOTRANSITION)
          ?DaylightStartTime{PROP:Hide} = CHOOSE(cTzi.DaylightStartTime = TZI_NOTRANSITION)
          ?StandardStartDate{PROP:Hide} = CHOOSE(cTzi.StandardStartDate = TZI_NOTRANSITION)
          ?DaylightStartDate{PROP:Hide} = CHOOSE(cTzi.DaylightStartDate = TZI_NOTRANSITION)
        END
      END
    END
  END
  CLOSE(W)
